import type { NextPage } from "next";
import Head from "next/head";
import { useCallback, useEffect, useMemo } from "react";
import { useDispatch, useSelector } from "react-redux";
import Link from "next/link";

import { userRegister } from "core/redux/actions/auth";
import styles from "styles/pages/AuthPage.module.scss";
import Input from "core/uikit/Input";
import Button from "core/uikit/Button";
import { IRootReducer } from "core/redux/reducers";
import { IAuthState } from "core/redux/reducers/auth";
import { useForm } from "core/hooks/useForm";
import redirectTo from "core/utils/redirectTo";
import authTokenService from "core/services/authTokenService";
import TgAuth from "core/uikit/TgAuth/TgAuth";

const Home: NextPage = () => {
  const dispatch = useDispatch();
  const {
    isAuthInProgress,
    registerError
  } = useSelector<IRootReducer, IAuthState>((store)=>store.auth);

  const handleAuth = useCallback((userData)=>{
    // dispatch(userRegister({
    //   email: formData.email
    // }))
    console.log(userData);
  }, [dispatch])

  var {
    onChangeField,
    handleSubmit,
    formData
  } = useForm(handleAuth);
  
  const authLink = useMemo(()=>{
    return registerError === 'Пользователь уже существует' ? `/auth/${formData.email}` : '/auth'
  }, [registerError, formData])

  useEffect(()=>{
    if(authTokenService.hasTokenInLocalstorage()) {
      redirectTo('/auth/user');
    }
  }, [])

  

  return (
    <div className={styles.page}>
      <Head>
        <title>Create Next App</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="icon" href="/favicon.ico" />
      </Head>
      <main className={styles.main}>
        <div className={styles.authCard}>
          {isAuthInProgress && <div className={styles.authCard__loader}/>}
          <span className={styles.authCard__brand}>MD.Cafe</span>

          <div className={styles.authCard__content}>
            <h1 className={styles.authCard__title}>Регистрация</h1>
            <h2 className={styles.authCard__subtitle}>Создание аккаунта в системе</h2>
            <hr />
            {registerError && (
              <div className={styles.error__wrapper}>
                <div className={styles.error}>{registerError}</div>
              </div>
            )}
            <TgAuth />
            <form className={styles.authForm} onSubmit={handleSubmit}>
              <Input 
                label="Почта"
                name="email"
                onChange={onChangeField('email')}
              />
              <Button
                theme='primary'
                size='md'
                type="submit"
              >
                Создать аккаунт
              </Button>
            </form>
            <div className={styles.authForm__changeAction}>
              <span>
                {'Если вы уже регистрировались в системе, то\u00A0'}
              </span>
              <Link href={authLink}>войдите в свой аккаунт</Link>
            </div>
          </div>

          <span className={styles.authCard__copy}>Powered by <a>M.Dev Group</a></span>
        </div>
      </main>
    </div>
  );
};

export default Home;
